<?php

/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Controllers\Administrator;

use App\Exceptions\DefaultException;
use App\Http\Base\BaseApiController;
use App\Http\Base\BaseController;
use App\Http\Handler\SyncHandler;
use App\Http\Handler\CurlHandler;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use App\Http\Services\ItempopenerimaanService;
use App\Http\Services\PopenerimaanService;

class ItempopenerimaanController extends BaseController
{
    protected $baseService;

    /**
     * Itempopenerimaan constructor.
     */
    public function __construct()
    {
        parent::__construct();
        $this->baseService = new ItempopenerimaanService();
        $this->po = new PopenerimaanService();
    }

    /**
     * @param Request $request
     * @return \Illuminate\Http\JsonResponse
     */
    public function search(Request $request)
    {
        $data = $this->baseService->paging($request->all());
        echo json_encode($data);
    }

    /**
     * @param Request $request
     * @param $id
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function show(Request $request, $id)
    {
        $auth = json_decode($request->session()->get('auth'));
        if ($auth->jabatan == "Administrator" || $auth->jabatan == "Nahkoda" || true) {
            $po = (object) [
                "poNumber" => $id,
                "kapalId" => $auth->kapalId
            ];
            $popenerimaan = $this->po->showBasedOnPONumber($request, $po);
            $this->data["popenerimaan"] = $this->po->show($popenerimaan->id);
            if ($this->data["popenerimaan"]) {
                $this->data["items"] = $this->baseService->showBasedOnPoNumber($request, $this->data["popenerimaan"]);
                return view("modules.itempopenerimaan.itempopenerimaan_show", $this->data);
            } else {
                return redirect()->back()->with("errMessage", "No data found. Please check this with your Administrator/Nahkoda.");
            }
        } else {
            return redirect()->to("administrator/")->with("errMessage", "Sorry, you don't have access to this page!" . $auth->jabatan);
        }
    }
}
